/*****************************************************************************
 UNIVERSIDAD DE ZARAGOZA
 DEPARTAMENTO DE INFORMATICA E INGENIERIA DE SISTEMAS
 AREA DE LENGUAJES Y SISTEMAS INFORMATICOS
******************************************************************************
******************************************************************************
 Fichero     :  conectividad.c
 Asignatura  :  Vision por Computador
 Fecha       :  2003-02
 Autor       :
******************************************************************************/


/*****************************************************************************
                              F U N C I O N E S
******************************************************************************/

/*****************************************************************************/
   int blobs_que_toca(int seg, int blobs[])
   /*****************************************************************************
   Dado el segmento seg, esta funcion devuelve como resultado el numero de
   blobs correspondientes a segmentos de la fila anterior que toca, y en el vector 
   blobs cuales son los blobs que toca.
   ******************************************************************************/
      { 
      }

/*****************************************************************************/
   void conectividad ()
   /*****************************************************************************
   A partir del codigo run-length de una imagen, previamente generado y
   almacenado en la variable rle, hace el analisis de
   conectividad, completando la informacion de la rle con los
   datos de cada blob que aparece en la imagen, segun la vecidad definida
   en las macros de vecindad.
   ******************************************************************************/
      {
      int i, s, b;
      int n, blobs[MAX_COLUMNAS];
   
      for (i = 0; i < NFILAS; ++i)
         {
         if (PRIMER_SEGMENTO(i) != NULO) /* la fila no esta vacia */
            {
            if (DEBUG) 
               printf("conectividad, fila: %d, segs: %d\n", 
                     i, ULTIMO_SEGMENTO(i) - PRIMER_SEGMENTO(i) + 1);
            for (s = PRIMER_SEGMENTO(i); s <= ULTIMO_SEGMENTO(i); ++s)
               {
               n = blobs_que_toca (s, blobs);
            
               if (n == 0) /* blob nuevo */
                  crear_blob(s);
               else if (n == 1) /* toca solo un blob */
                  anadir_segmento_a_blob(blobs[0], s);
               else /* toca a mas de un blob */
                  {
                  for (b = 1; b < n; ++b)
                     fusionar_blobs(blobs[0], blobs[b]);
               
                  anadir_segmento_a_blob(blobs[0], s);
                  }		
               }
            }
         }
      fprintf(stderr, "Blobs totales: %d\n", NBLOBS);
      }

/*****************************************************************************/
   void filtro_de_tamano (int minpixels, int maxpixels)
   /*****************************************************************************
   Elimina los blobs que tienen menos que minpixels o mas que maxpixels.
   ******************************************************************************/
      {
      /****************
      Cuando decidas eliminar un blob, debes ejecutar:

               PRIMERO (blob) = NULO;
               USADOS--;
      *****************/
      }

/*****************************************************************************/
   void analisis_de_conectividad (IMAGEN *binaria)
   /*****************************************************************************
   ******************************************************************************/
      {
      IMAGEN coloreada;
   
      inicializar_run_length ();
      run_length (binaria);

      inicializar_imagen (&coloreada, FILAS (*binaria), COLUMNAS (*binaria));
      descodificar_run_length (&coloreada);
      comparar_imagenes (binaria, &coloreada);
      conectividad ();
      filtro_de_tamano (0,1000000);
      eliminar_blobs_nulos ();
   
      inicializar_imagen (&coloreada, FILAS (*binaria), COLUMNAS (*binaria));
      colorear (&coloreada);
      ver_imagen (&coloreada, "coloreada");     
      }

