 /*****************************************************************************
 UNIVERSIDAD DE ZARAGOZA
 DEPARTAMENTO DE INFORMATICA E INGENIERIA DE SISTEMAS
 AREA DE LENGUAJES Y SISTEMAS INFORMATICOS
 ******************************************************************************
 ******************************************************************************
 Fichero     :  umbralizar.c
 Asignatura  :  Vision por Computador
 Fecha       :  2003-02
 Autor       :
 ******************************************************************************/

 /*****************************************************************************
                              D E F I N E S
 ******************************************************************************/

 #define OBJETO  0
 #define FONDO   1
 #define ABS(a) ((a) > 0? (a) : -(a))


 /*****************************************************************************/
   int umbral_ptile (HISTOGRAMA hist, double p)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i, total = 0;
      long n = 0;
      int umbral = 0;


      for (i = 0; i < GRISES; ++i)
         n += hist[i];

      n *= p;
      while ( (umbral < GRISES) && (total < n))
         {
         total +=  hist[umbral];
         umbral++;
         }

      return umbral;
      }

 /*****************************************************************************/
   void histograma (IMAGEN *entrada, HISTOGRAMA hist)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i, f, c;

      for (i = 0; i < GRISES; ++i)
         hist[i] = 0;

      for (f = 0; f < FILAS (*entrada); f++)
         for (c = 0; c < COLUMNAS (*entrada); c++)
            hist[PIXEL (*entrada, f, c)]++;
      }


 /*****************************************************************************/
   double umbral_promedio (HISTOGRAMA hist, int min, int max)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i;
      double p = 0, n = 0;

      for (i = min; i <= max; ++i)
      {
	  n += hist[i];
	  p += i * hist[i];
      }

      return (p / n);
      }

 /*****************************************************************************/
   int umbral_isodata (HISTOGRAMA hist)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i, m1, m2;
      int tant, t = umbral_promedio(hist, 0, 255);

      m1 = umbral_promedio(hist, 0, t);
      m2 = umbral_promedio(hist, t+1, 255);
      tant = t;
      t = (m1 + m2) / 2;
      i = 1;
      do {
          printf ("i: %d, umbral: %d\n", i, t);
          m1 = umbral_promedio(hist, 0, t);
          m2 = umbral_promedio(hist, t+1, 255);
          tant = t;
          t = (m1 + m2) / 2;
	  ++i;
      } while (t != tant);

      return (t);

      }

 /*****************************************************************************/
   int umbral_modal (HISTOGRAMA hist)

   /*****************************************************************************
   ******************************************************************************/
      {
      int k;
      long int p, q, t;

   /* busco el maximo */
      p = 0;
      for (k = 1; k < GRISES; ++k)
         if (hist[k] > hist[p])
            p = k;

   /* busco el siguiente maximo */
      q = 0;
      for (k = 1; k < GRISES; ++k)
         if ((k-p)*(k-p)*hist[k] > (q-p)*(q-p)*hist[q])
            q = k;

   /* ordenarlos */
      if (p > q)
         {
         int t;

         t = p;
         p = q;
         q = t;
         }

   /* busco el minimo entre los dos */
      t = p;
      for (k = p+1; k <= q; ++k)
         if (hist[k] < hist[t])
            t = k;

      printf("p: %d, q: %d, t: %d\n", p, q, t);
      return t;
      }

 /*****************************************************************************/
   void umbralizar (IMAGEN *entrada, IMAGEN *salida, int umbral)

   /*****************************************************************************
   ******************************************************************************/
      {
      int f, c;

      inicializar_imagen (salida, FILAS (*entrada), COLUMNAS (*entrada));
      /*
      * completar suponiendo los objetos oscuros y el fondo claro
      * y catalogando pixels objeto como OBJETO (0) y pixels fondo como FONDO (1)
      */

      for (f = 0; f < FILAS (*entrada); f++)
           for (c = 0; c < COLUMNAS (*entrada); c++)
                   PIXEL (*salida, f, c) = (PIXEL (*entrada, f, c) <= umbral ? OBJETO : FONDO);

      }

 /*****************************************************************************/
   void laplaciano (IMAGEN *entrada, IMAGEN *salida)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i, j;

      inicializar_imagen (salida, FILAS (*entrada), COLUMNAS (*entrada));

      for (i = 1; i < FILAS (*salida)-1; i++)
         for (j = 1; j < COLUMNAS (*salida)-1; j++)
            {
            int r;

            r = -4 * PIXEL (*entrada,i,j);
            r +=  PIXEL (*entrada,i-1,j);
            r +=  PIXEL (*entrada,i+1,j);
            r +=  PIXEL (*entrada,i,j-1);
            r +=  PIXEL (*entrada,i,j+1);
            PIXEL (*salida,i,j) = ABS(r) / 4;
            }
      }

 /*****************************************************************************/
   void histograma_con_laplaciano (IMAGEN *entrada, IMAGEN *laplaciana, int umbral,
                     HISTOGRAMA hist)

   /*****************************************************************************
   ******************************************************************************/
      {
      int i, j;


      for (i = 0; i < GRISES; ++i)
         hist[i] = 0;

      for (i = 0; i < FILAS (*entrada); i++)
         for (j = 0; j < COLUMNAS (*entrada); j++)
            if (PIXEL (*laplaciana,i,j) >=  umbral)
               hist[PIXEL (*entrada,i,j)]++;
      }

 /*****************************************************************************/
   int umbral_weskza (IMAGEN *entrada)

   /*****************************************************************************
   ******************************************************************************/
      {
      IMAGEN laplaciana, salida;
      HISTOGRAMA hist;
      int umbral, umbral_laplaciano;
      char mensaje[200];

      histograma (entrada, hist);
      umbral = umbral_promedio (hist, 0, 255);
  sprintf(mensaje, "umbral promedio = %d", umbral);
      ver_histograma (hist, umbral, mensaje);
 
            laplaciano (entrada, &laplaciana);

      histograma (&laplaciana, hist);
      umbral_laplaciano = umbral_ptile (hist, 0.90);

   /*
   sprintf(mensaje, "umbral laplaciano = %d", umbral_laplaciano);
      ver_histograma (hist, umbral_laplaciano, mensaje);
  */

      umbralizar (&laplaciana, &salida, umbral_laplaciano);

   ver_imagen (&salida, "laplaciana binaria");


      histograma_con_laplaciano (entrada, &laplaciana, umbral_laplaciano, hist);
      umbral = umbral_promedio (hist, 0, 255);

   sprintf(mensaje, "umbral promedio para weskza = %d", umbral);
      ver_histograma (hist, umbral, mensaje);

   return umbral;
      }
